/****************************************************************************

  gluicube2.cpp
  	uses glui interface to change axis of rotation for cube
	mouse input also changes axis of rotation and updates the GUI

  
****************************************************************************/
#include <stdlib.h>
#include <GL/glut.h>
#include <GL/glui.h>


int   axis=2;
int   axis_flag=2; 	// initialize axis_flag so radio button begins on z
int   main_window;
static GLfloat theta[] = {0.0,0.0,0.0};



	GLfloat vertices[][3] = {{-1.0,-1.0,-1.0},{1.0,-1.0,-1.0},
	{1.0,1.0,-1.0}, {-1.0,1.0,-1.0}, {-1.0,-1.0,1.0}, 
	{1.0,-1.0,1.0}, {1.0,1.0,1.0}, {-1.0,1.0,1.0}};

	GLfloat normals[][3] = {{-1.0,-1.0,-1.0},{1.0,-1.0,-1.0},
	{1.0,1.0,-1.0}, {-1.0,1.0,-1.0}, {-1.0,-1.0,1.0}, 
	{1.0,-1.0,1.0}, {1.0,1.0,1.0}, {-1.0,1.0,1.0}};

	GLfloat colors[][3] = {{0.0,0.0,0.0},{1.0,0.0,0.0},
	{1.0,1.0,0.0}, {0.0,1.0,0.0}, {0.0,0.0,1.0}, 
	{1.0,0.0,1.0}, {1.0,1.0,1.0}, {0.0,1.0,1.0}};



/* GLUI CODE */
/** Pointers to the windows and some of the controls we'll create **/
GLUI 		*glui;
GLUI_RadioGroup *radio;
GLUI_Panel      *obj_panel;



/**************************************** control_cb() *******************/
/* GLUI control callback                                                 */

void control_cb( int control )
{
	/* this function is totally unnecessary here since the values
	 * needed by the code are the same as set by the radiobuttons */
	
  if ( control == 1 ) {
    /*** change in axis of rotation ***/
    axis = axis_flag; 
  }
}

void polygon(int a, int b, int c , int d)
{
/* draw a polygon via list of vertices */
 	glBegin(GL_POLYGON);
		glColor3fv(colors[a]);
		glNormal3fv(normals[a]);
		glVertex3fv(vertices[a]);
		glColor3fv(colors[b]);
		glNormal3fv(normals[b]);
		glVertex3fv(vertices[b]);
		glColor3fv(colors[c]);
		glNormal3fv(normals[c]);
		glVertex3fv(vertices[c]);
		glColor3fv(colors[d]);
		glNormal3fv(normals[d]);
		glVertex3fv(vertices[d]);
	glEnd();
}

void colorcube(void)
{
/* map vertices to faces */
	polygon(0,3,2,1);
	polygon(2,3,7,6);
	polygon(0,4,7,3);
	polygon(1,2,6,5);
	polygon(4,5,6,7);
	polygon(0,1,5,4);
}



void display(void)
{
/* display callback, clear frame buffer and z buffer,
   rotate cube and draw, swap buffers */

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glRotatef(theta[0], 1.0, 0.0, 0.0);
	glRotatef(theta[1], 0.0, 1.0, 0.0);
	glRotatef(theta[2], 0.0, 0.0, 1.0);

	colorcube();
	
	glFlush();
	glutSwapBuffers();
}


void spinCube()
{

/* Idle callback, spin cube 2 degrees about selected axis */

	theta[axis] += 2.0;
	if( theta[axis] > 360.0 ) theta[axis] -= 360.0;

	/* GLUI CODE */
        if ( glutGetWindow() != main_window ) 
              glutSetWindow(main_window);  
	glutPostRedisplay();
	radio->set_int_val(axis);
}


void mouse(int btn, int state, int x, int y)
{

/* mouse callback, selects an axis about which to rotate */

	if(btn==GLUT_LEFT_BUTTON && state == GLUT_DOWN) axis = 0;
	if(btn==GLUT_MIDDLE_BUTTON && state == GLUT_DOWN) axis = 1;
	if(btn==GLUT_RIGHT_BUTTON && state == GLUT_DOWN) axis = 2;
 
}


void myReshape(int w, int h)
{
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	if (w <= h)
		glOrtho(-2.0, 2.0, -2.0 * (GLfloat) h / (GLfloat) w,
			2.0 * (GLfloat) h / (GLfloat) w, -10.0, 10.0);
	else
		glOrtho(-2.0 * (GLfloat) w / (GLfloat) h,
			2.0 * (GLfloat) w / (GLfloat) h, -2.0, 2.0, -10.0, 10.0);
	glMatrixMode(GL_MODELVIEW);
}




/**************************************** main() ********************/

void main(int argc, char* argv[])
{
  /****************************************/
  /*   Initialize GLUT and create window  */
  /****************************************/

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
  glutInitWindowPosition( 50, 50 );
  glutInitWindowSize( 500, 500 );
 
  main_window = glutCreateWindow( "GLUI Example 3" );
  glutDisplayFunc( display );
  glutReshapeFunc( myReshape );  
  glutMouseFunc(mouse);
	  

  /****************************************/
  /*       Set up OpenGL lights           */
  /****************************************/


  /****************************************/
  /*          Enable z-buferring          */
  /****************************************/

  glEnable(GL_DEPTH_TEST);

  /****************************************/
  /*         Here's the GLUI code         */
  /****************************************/


  glui = GLUI_Master.create_glui( "GLUI", 0, 400, 50 ); /* name, flags,
							   x, and y */
  glui->add_statictext( "GLUI cube example" ); 
  obj_panel = glui->add_panel( "Cube Control" );

  /***** Control for the object type *****/

  GLUI_Panel *type_panel = glui->add_panel_to_panel( obj_panel, "Rotation");
  radio = glui->add_radiogroup_to_panel(type_panel,&axis_flag,1,control_cb);
  glui->add_radiobutton_to_group( radio, "x-axis" );
  glui->add_radiobutton_to_group( radio, "y-axis" );
  glui->add_radiobutton_to_group( radio, "z-axis" );


  glui->add_button( "Quit", 0,(GLUI_Update_CB)exit );


  /**** Link windows to GLUI, and register idle callback ******/
  
  glui->set_main_gfx_window( main_window );

  /* We register the idle callback with GLUI, not with GLUT */
  GLUI_Master.set_glutIdleFunc( spinCube );

  /**** Regular GLUT main loop ****/  
  glutMainLoop();
}

