include <GL/glut.h>
include "glui.h"
include "glwrap.hpp"
include "opengl.sol"
include "glutw.sol"
include "gluiw.sol"

 


int main(int argc, array argv)


  // Added for Scriptol compatibility

  GLUI_Master_Object GLUI_Master_Ptr = null
  GLUI glui_Ptr = null
  ~~
   GLUI_Master_Ptr = & GLUI_Master;
  ~~

  // Initialize GLUT and create window  

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH )
  glutInitWindowPosition( 50, 50 )
  glutInitWindowSize( 300, 300 )
 
  main_window = glutCreateWindow( "GLUI Example 4" )

  glutDisplayFunc( "myGlutDisplay" )
  glutReshapeFunc( "myGlutReshape" )
  glutKeyboardFunc( "myGlutKeyboard" )
  glutMotionFunc( "myGlutMotion" )
  glutMouseFunc( "myGlutMouse" )

  // Set up OpenGL lights

  glEnable(GL_LIGHTING)
  glEnable( GL_NORMALIZE )

  glEnable(GL_LIGHT0)
  glLightfv(GL_LIGHT0, GL_AMBIENT, light0_ambient)
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_diffuse)
  glLightfv(GL_LIGHT0, GL_POSITION, light0_position)

  glLightfv(GL_LIGHT1, GL_AMBIENT, light1_ambient)
  glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse)
  glLightfv(GL_LIGHT1, GL_POSITION, light1_position)

  // Enable z-buferring

  glEnable(GL_DEPTH_TEST)

  // Here's the GLUI code

  printf( "GLUI version: %3.2f\n", GLUI_Master_Ptr.get_version() )

  glui_Ptr = GLUI_Master_Ptr.create_glui( "GLUI", 0, 400, 50 )  // name, flags, x, and y 

  // Add invisible panel to hold rest of controls 

  GLUI_Panel panel1 = glui_Ptr.add_panel( "", GLUI_PANEL_NONE )

  obj_panel = glui_Ptr.add_panel_to_panel( panel1, "Objects" )

  // Control for object params

  checkbox = glui_Ptr.add_checkbox_to_panel( obj_panel, "Wireframe",
             alias wireframe, 1,  "control_cb" )

  spinner  = glui_Ptr.add_spinner_to_panel( obj_panel, "Segments:",
             GLUI_SPINNER_INT, alias segments)

  spinner.set_int_limits( 3, 60 )
  spinner.set_alignment( GLUI_ALIGN_RIGHT )

  GLUI_Spinner scale_spinner =  glui_Ptr.add_spinner_to_panel( obj_panel, "Scale:",
                                GLUI_SPINNER_FLOAT, alias scale)
  scale_spinner.set_float_limits( .2f, 4.0 )
  scale_spinner.set_alignment( GLUI_ALIGN_RIGHT )

  GLUI_Panel panel2 = glui_Ptr.add_panel_to_panel( obj_panel, "",
                                                 GLUI_PANEL_NONE )
  glui_Ptr.add_checkbox_to_panel( panel2, "Sphere", alias show_sphere )
  glui_Ptr.add_column_to_panel( panel2 );
  glui_Ptr.add_checkbox_to_panel( panel2, "Torus", alias show_torus )


  // Start a new column in this panel

  glui_Ptr.add_column_to_panel(panel1, false); // 'false' means don't draw bar 


  // Add some controls for lights

  GLUI_Panel light0 = glui_Ptr.add_panel_to_panel( panel1, "Light 1" )
  GLUI_Panel light1 = glui_Ptr.add_panel_to_panel( panel1, "Light 2" )

  glui_Ptr.add_checkbox_to_panel( light0, "Enabled", alias light0_enabled,
                               LIGHT0_ENABLED_ID, "control_cb" )

  light0_spinner = glui_Ptr.add_spinner_to_panel( light0, "Intensity:",
                   GLUI_SPINNER_FLOAT, alias light0_intensity,
                   LIGHT0_INTENSITY_ID, "control_cb" )

  light0_spinner.set_float_limits( 0.0, 1.0 )

  glui_Ptr.add_checkbox_to_panel( light1, "Enabled", alias light1_enabled,
                               LIGHT1_ENABLED_ID, "control_cb" )

  light1_spinner = glui_Ptr.add_spinner_to_panel( light1, "Intensity:",
                   GLUI_SPINNER_FLOAT, alias light1_intensity,
                   LIGHT1_INTENSITY_ID, "control_cb" )

  light1_spinner.set_float_limits( 0.0, 1.0 )

  light1_spinner.disable()   // Disable this light initially 

  
  // A 'quit' button

//  glui_Ptr.add_button( "Quit", 0, "exit" )

  ~~
   glui_Ptr->add_button("Quit", 0, exit);
  ~~

  // Link windows to GLUI, and register idle callback
  
  glui_Ptr.set_main_gfx_window( main_window )

  // We register the idle callback with GLUI, *not* with GLUT

  GLUI_Master_Ptr.set_glutIdleFunc( "myGlutIdle" )

  // Regular GLUT main loop

  glutMainLoop()

return 0


