

/*

  Scriptol Header file for GLUI


*/

extern

 real xy_aspect
 int last_x
 int last_y
 real rotationX
 real rotationY


 int   wireframe
 int   obj_type
 int   segments
 int   segments2
 int   light0_enabled
 int   light1_enabled
 real light0_intensity
 real light1_intensity
 int   main_window
 real scale
 int   show_sphere
 int   show_torus



class GLUI_String : /class

class Arcball : /class

class GLUquadricObj : /class

class RGBc

  byte r
  byte g
  byte b
    
  void set(byte, byte, byte)
    
//  RGBc( void ) 
//  RGBc( byte, byte, byte )

/class


 define GLfloat  
 define FILE


 GLfloat light0_ambient
 GLfloat light0_diffuse
 GLfloat light0_position

 GLfloat light1_ambient
 GLfloat light1_diffuse
 GLfloat light1_position


void control_cb(int)
void draw_axes(real)






class GLUI_Node 
  GLUI_Node first_sibling()
  GLUI_Node last_sibling()
  GLUI_Node prev()
  GLUI_Node next()
  GLUI_Node first_child()
  GLUI_Node last_child() 
  GLUI_Node parent()       

  void      link_this_to_parent_last( GLUI_Node )
  void      link_this_to_parent_first( GLUI_Node )
  void      link_this_to_sibling_next( GLUI_Node )
  void      link_this_to_sibling_prev( GLUI_Node )
  void      unlink()

  void dump( FILE, cstring )

/class


 int glui_img_checkbox_0
 int glui_img_checkbox_1
 int glui_img_radiobutton_0
 int glui_img_radiobutton_1
 int glui_img_uparrow
 int glui_img_downarrow
 int glui_img_leftarrow
 int glui_img_rightarrow
 int glui_img_spinup_0
 int glui_img_spinup_1
 int glui_img_spindown_0
 int glui_img_spindown_1
 int glui_img_checkbox_0_dis
 int glui_img_checkbox_1_dis
 int glui_img_radiobutton_0_dis
 int glui_img_radiobutton_1_dis
 int glui_img_spinup_dis
 int glui_img_spindown_dis
 int glui_img_listbox_up
 int glui_img_listbox_down
 int glui_img_listbox_up_dis

 int * bitmap_arrays



class GLUI_Bitmap 
  byte pixels
  int w
  int h
  
  void load_from_array( int * x)

/class


class GLUI_StdBitmaps

//  GLUI_Bitmap bitmaps[ GLUI_STDBITMAP_NUM_ITEMS ]

  void draw( int, int, int)
  

/class


void test001()
void test002(byte, int, int)
void test003(int, int, int)
void test004(int, int)
void test005(int,int)
void test006(int,int,int,int)
void test007(int)
void test008(int,int)
void test009()
void test010(int)

define f = "test001"
define glut_keyboard_CB = "test002"
define glut_special_CB = "test003"
define glut_reshape_CB = "test004"
define glut_passive_motion_CB = "test005"
define glut_mouse_CB = "test006"
define glut_visibility_CB = "test007"
define glut_motion_CB = "test008"
define glut_display_CB = "test009"
define glut_entry_CB = "test010"
    
define GLUI_Update_CB = "control_cb"



define Int1_CB as
define Int2_CB as
define Int3_CB as
define Int4_CB as

define control_cb_type = "control_cb"
define draw_axes_type = "draw_axes"


class GLUI_Control is GLUI_Node


  int             w
  int             h
  int             x_abs
  int             y_abs
  int             x_off
  int             y_off_top
  int             y_off_bot
  int             contain_x
  int             contain_y
  int             contain_w
  int             contain_h
  int             active
  int             active_type
  int             can_activate
  int             spacebar_mouse_click
  integer         user_id
  integer         type
  int             is_container
  int             alignment
  GLUI_Update_CB  callback
  void            *ptr_val
  real           float_val
  int             enabled
  int             int_val
//  real            float_array_val[30]
  int             state
  GLUI_String     name
//  GLUI_String     text              
//  GLUI    glui
  void            font
  int             live_type
  int             live_inited
  int             last_live_int
  real           last_live_float
  GLUI_String     last_live_text
//  real           last_live_float_array[30]
  int             float_array_size

  int             collapsible
  int             is_open
  GLUI_Node       collapsed_node
  int             hidden

  void   set_name( cstring )
  void   set_int_val( int new_int )
  void   set_float_val( real new_float )
  void   set_ptr_val( void *new_ptr )
  void   set_float_array_val( real * )

  real  get_float_val()      
  int    get_int_val()        
  void   get_float_array_val( real * )
  
  int mouse_down_handler( int local_x, int local_y ) 
  int mouse_up_handler( int local_x, int local_y, int inside )
  int mouse_held_down_handler( int local_x, int local_y, int inside)
  int key_handler( byte, int )
  int special_handler( int, int )

  void update_size() 
  void idle()        
  int  mouse_over( int, int, int )
  
  void enable() 
  void disable()
  void activate( int )   
  void disactivate()   

  void         hide_internal( int recurse )
  void         unhide_internal( int recurse )

  int          can_draw() 

  void align()
  void         pack( int x, int y )
  void         pack_old( int x, int y )    
  void         draw_recursive( int x, int y )
  int          set_to_glut_window()
  void         restore_window( int orig )
  void         translate_and_draw_front()
  void         translate_to_origin() 
  void         draw( int x, int y )
  void         set_font( void *new_font )
  void        *get_font()
  int          string_width( cstring )
  int          char_width( char c )

  void         draw_name( int x, int y )
  void         draw_box_inwards_outline( int x_min, int x_max, 
                     int y_min, int y_max )
  void         draw_box( int x_min, int x_max, int y_min, int y_max,
             real r, real g, real b )
  void         draw_bkgd_box( int x_min, int x_max, int y_min, int y_max )
  void         draw_emboss_box( int x_min, int x_max,int y_min,int y_max)
  void         draw_string( cstring )
  void         draw_char( char c )
  void         draw_active_box( int x_min, int x_max, int y_min, int y_max )
  void         set_to_bkgd_color()
    
  void         set_w( int new_w )
  void         set_h( int new_w )
  void         set_alignment( int new_align )
  void         sync_live( int recurse, int draw )  /* Reads live variable */
  void         init_live()
  void         output_live( int update_main_gfx )        /** Writes live variable **/
  void set_text( cstring )  
  void         execute_callback()
//  void         get_this_column_dims( int *, int *, int *, int *,int *, int * )
  int  needs_idle( )

  
/class




class GLUI_Glut_Window is GLUI_Node 

  int    glut_window_id


/class



class GLUI_Panel is GLUI_Control

  void draw(int, int)
  void set_name( cstring)
  void set_type( int )

  void update_size( )

/class


class GLUI_Main is GLUI_Node 

  int           main_gfx_window_id
  int           mouse_button_down
  int           glut_window_id
  int           top_level_glut_window_id
  GLUI_Control  active_control
  GLUI_Control  mouse_over_control
  GLUI_Panel    main_panel
  int           curr_cursor
  int           w
  int           h
  integer       flags 
  int           closing
  int           parent_window
  int           glui_id


  GLUI_Control  find_control( int x, int y )
  GLUI_Control  find_next_control( GLUI_Control )
  GLUI_Control  find_next_control_rec( GLUI_Control)
  GLUI_Control  find_next_control_( GLUI_Control )
  GLUI_Control  find_prev_control( GLUI_Control)
  void           create_standalone_window( cstring, int =-1, int =-1 )
  void           create_subwindow( int,int)
  void           setup_default_glut_callbacks()

  void           mouse(int button, int state, int, int)
  void           keyboard(byte, int, int)
  void           special(int, int, int)
  void           passive_motion(int, int)
  void           reshape( int, int )
  void           visibility(int state)
  void           motion(int, int)
  void           entry(int)
  void           display()
  void           idle()


  GLUI_Control controls
  int           num_controls

  int           add_control( GLUI_Node, GLUI_Control )


  GLUI_StdBitmaps  std_bitmaps
  GLUI_String      window_name
  RGBc             bkgd_color
//  real             bkgd_color_f[3]

  void            *font
  int              curr_modifiers

  void         adjust_glut_xy( int alias, int alias) 
  void         activate_control( GLUI_Control, int)
  void         align_controls( GLUI_Control )
  void         restore_draw_buffer( int buffer_state )
  void         disactivate_current_control( )
  void         draw_raised_box( int , int , int , int  )
  void         draw_lowered_box( int, int, int, int )
  int          set_front_draw_buffer( )
  void         post_update_main_gfx( )
  void         pack_controls( )
  void         close_internal( )
  void         check_subwindow_position( )
  void         set_ortho_projection( )
  void         set_viewport( )
  void         refresh( )
/class








class GLUI_Button is  GLUI_Control

  int currently_inside

  int  mouse_down_handler( int local_x, int local_y )
  int  mouse_up_handler( int local_x, int local_y, int same )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
  int  key_handler( byte,int modifiers )
  
  void draw( int x, int y )
  void draw_pressed()
  void draw_unpressed()
  void draw_text( int sunken )

  void update_size()


/class



class GLUI_Checkbox is  GLUI_Control

  int  orig_value
  int  currently_inside
  int  text_x_offset

  int  mouse_down_handler( int local_x, int local_y )
  int  mouse_up_handler( int local_x, int local_y, int inside )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
  int  key_handler( byte,int modifiers )
  
  void update_size()

  void draw( int x, int y )

  void draw_active_area()
  void draw_checked()
  void draw_unchecked()
  void draw_X()
  void draw_empty_box( )
  void set_int_val( int )


/class



class GLUI_Column is GLUI_Control

  void draw( int x, int y )

/class





class GLUI_Rollout is GLUI_Panel

  int  currently_inside
  int  initially_inside
  GLUI_Button  button

  void draw( int x, int y )
  void draw_pressed()
  void draw_unpressed()
  int mouse_down_handler( int local_x, int local_y )
  int mouse_up_handler( int local_x, int local_y, int inside )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
        
  void  open() 
  void  close()

  void update_size()

/class



class GLUI_RadioGroup is GLUI_Control

  int  num_buttons

  void draw( int x, int y )
  void set_name( cstring )
  void set_int_val( int )
  void set_selected( int )

  void draw_group( int )

/class



class GLUI_RadioButton is GLUI_Control

  int orig_value
  int currently_inside
  int text_x_offset

  int  mouse_down_handler( int local_x, int local_y )
  int  mouse_up_handler( int local_x, int local_y, int inside )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
  
  void draw( int x, int y )
  void update_size()

  void draw_active_area()
  void draw_checked()
  void draw_unchecked()
  void draw_O()

  GLUI_RadioGroup group

/class


class GLUI_Separator is GLUI_Control

  void draw( int x, int y )

/class


 
class GLUI_Spinner is GLUI_Control

  int           currently_inside
  int           state
  real          growth
  real          growth_exp
  int           last_x
  int           last_y
  int           data_type
  int           callback_count
  int           last_int_val
  real          last_float_val
  int           first_callback
  real          user_speed

//  GLUI_EditText edittext

  int  mouse_down_handler( int local_x, int local_y )
  int  mouse_up_handler( int local_x, int local_y, int same )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
  int  key_handler( byte, int modifiers )
  int  special_handler( int key,int modifiers )
  
  void draw( int x, int y )
  void draw_pressed()
  void draw_unpressed()
  void draw_text( int sunken )

  void update_size()

  void set_float_limits( real low,real high,int limit_type=1)
  void set_int_limits( int low, int high,int limit_type=1)
  int  find_arrow( int local_x, int local_y )
  void do_drag( int x, int y )
  void do_callbacks()
  void draw_arrows()
  void do_click()
  void idle()
  int  needs_idle()

  char *get_text()

  void set_float_val( real new_val )
  void set_int_val( int new_val )
  real  get_float_val()
  int    get_int_val()
  void increase_growth()
  void reset_growth()

  void set_speed( real )

/class




class GLUI_EditText is  GLUI_Control

  int                 has_limits
  int                 data_type
  GLUI_String         orig_text
  int                 insertion_pt
  int                 title_x_offset
  int                 text_x_offset
  int                 substring_start
  int                 substring_end
  int                 sel_start
  int                 sel_end
  int                 num_periods
  int                 last_insertion_pt
  real                float_low
  real                float_high
  int                 int_low
  int                 int_high
  GLUI_Spinner        spinner
  int                 debug
  int                 draw_text_only


  int  mouse_down_handler( int local_x, int local_y )
  int  mouse_up_handler( int local_x, int local_y, int same )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
  int  key_handler( byte, int modifiers )
  int  special_handler( int key,int modifiers )
  
  void activate( int how )
  void disactivate()

  void draw( int x, int y )

  int  mouse_over( int state, int x, int y )

  int  find_word_break( int start, int direction )
  int  substring_width( int start, int end )
  void clear_substring( int start, int end )
  int  find_insertion_pt( int x, int y )
  int  update_substring_bounds()
  void update_and_draw_text()
  void draw_text( int x, int y )
  void draw_insertion_pt()
  void set_numeric_text()
  void update_x_offsets()
  void update_size()

  void set_float_limits( real low,real high,int limit_type=1)
  void set_int_limits( int low, int high, int limit_type=1 )
  void set_float_val( real new_val )
  void set_int_val( int new_val )
  void set_text( cstring)
  char *get_text()

  void dump( FILE out, cstring )


/class




class GLUI_StaticText is GLUI_Control

  void set_text( cstring )
  void draw( int x, int y )
  void draw_text()
  void update_size()
  void erase_text()

/class


class GLUI_Listbox_Item is GLUI_Node 

//  GLUI_String text
  int         id

/class


class GLUI_Listbox is GLUI_Control

  GLUI_String       curr_text
  GLUI_Listbox_Item items_list
  int               depressed

  int  orig_value
  int  currently_inside
  int  text_x_offset
  int  title_x_offset
  int  glut_menu_id

  int  mouse_down_handler( int local_x, int local_y )
  int  mouse_up_handler( int local_x, int local_y, int inside )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
  int  key_handler( byte, int modifiers )
  int  special_handler( int key,int modifiers )

  void update_size()
  void draw( int, int )
  int  mouse_over( int state, int x, int y )

  void draw_active_area()
  void set_int_val( int new_val )
  void dump( FILE output )

  int  add_item( int id, cstring )
  int  delete_item( cstring )
  int  delete_item( int )
  int  sort_items()

  int  do_selection( int )

  void increase_width()

  GLUI_Listbox_Item get_item_ptr( cstring )
  GLUI_Listbox_Item get_item_ptr( int )
  
/class



class GLUI_Mouse_Interaction is GLUI_Control

  int            draw_active_area_only
    
  int  mouse_down_handler( int local_x, int local_y )
  int  mouse_up_handler( int local_x, int local_y, int inside )
  int  mouse_held_down_handler( int local_x, int local_y, int inside )
  int  special_handler( int key, int modifiers )
  void update_size()
  void draw( int x, int y )
  void draw_active_area()
  
  
/class
 

class GLUI_Rotation is GLUI_Mouse_Interaction

  Arcball       ball
  GLUquadricObj quadObj
  int           can_spin
  int      spinning
  real          damping
  
  int  iaction_mouse_down_handler( int local_x, int local_y )
  int  iaction_mouse_up_handler( int local_x, int local_y, int inside )
  int  iaction_mouse_held_down_handler( int local_x, int local_y, int inside )
  int  iaction_special_handler( int key, int modifiers )
  void iaction_init()
  void iaction_draw_active_area_persp()
  void iaction_draw_active_area_ortho()
  void iaction_dump( FILE output )

    
  void setup_texture()
  void setup_lights()
  void draw_ball( real radius )

  void init_ball()

  void reset()

  int  needs_idle()
  void idle()

  void copy_float_array_to_ball()
  void copy_ball_to_float_array()

  void set_spin( real damp_factor )

/class



class GLUI_Translation is GLUI_Mouse_Interaction

  int trans_type
  int down_x
  int down_y
  real scale_factor
  GLUquadricObj quadObj
  int   trans_mouse_code
  real orig_x
  real orig_y
  real orig_z
  int   locked

  int  iaction_mouse_down_handler( int local_x, int local_y )
  int  iaction_mouse_up_handler( int local_x, int local_y, int inside )
  int  iaction_mouse_held_down_handler( int local_x, int local_y, int inside )
  int  iaction_special_handler( int key, int modifiers )
  void iaction_init()
  void iaction_draw_active_area_persp()
  void iaction_draw_active_area_ortho()
  void iaction_dump( FILE output )

  void set_speed( real s )

  void setup_texture()
  void setup_lights()
  void draw_2d_arrow( int radius, int filled, int orientation ) 
  void draw_2d_x_arrows( int radius )
  void draw_2d_y_arrows( int radius )
  void draw_2d_z_arrows( int radius )
  void draw_2d_xy_arrows( int radius )

  int  get_mouse_code( int x, int y )


  real get_z() 
  real get_x() 

  void  set_z( real val )
  void  set_x( real val )
  void  set_y( real val )
  void  set_one_val( real val, int index )

/class




class GLUI is GLUI_Main

  void  add_column( int draw_bar = 1 )
  void  add_column_to_panel( GLUI_Panel , int draw_bar = 1 )

  void  add_separator( )
  void  add_separator_to_panel( GLUI_Panel)

  GLUI_RadioGroup add_radiogroup( int *l=null, int = -1, GLUI_Update_CB = null)

  GLUI_RadioGroup add_radiogroup_to_panel(  GLUI_Panel,  int * =null,
                   int = 1, GLUI_Update_CB =null )

  GLUI_RadioButton add_radiobutton_to_group(GLUI_RadioGroup, cstring )

  GLUI_Listbox add_listbox( cstring, int *live_var=null,
                 int id=-1, GLUI_Update_CB callback=null    )

  GLUI_Listbox add_listbox_to_panel( GLUI_Panel ,
                      char *name, int *live_var=null,
                      int id=-1, GLUI_Update_CB callback=null)

  GLUI_Rotation add_rotation( cstring, real *live_var=null,
                   int id=-1, GLUI_Update_CB callback=null  )

  GLUI_Rotation add_rotation_to_panel( GLUI_Panel,
                    cstring, real *=null,
                    int = -1, GLUI_Update_CB =null)
  
  GLUI_Translation add_translation( cstring, int, real *=null,
                     int =-1, GLUI_Update_CB =null )

  GLUI_Translation add_translation_to_panel( GLUI_Panel, cstring, int,
                real *=null, int = -1, GLUI_Update_CB =null)
  
  GLUI_Checkbox  add_checkbox( cstring, int *live_var=null,
                int id=-1, GLUI_Update_CB callback=null)
                
  GLUI_Checkbox  add_checkbox_to_panel( GLUI_Panel, cstring, 
                     int *live_var=null, int id=-1, 
                     GLUI_Update_CB callback=null)

  GLUI_Button  add_button( cstring, int =-1, GLUI_Update_CB = null)

  GLUI_Button  add_button_to_panel( GLUI_Panel, cstring, 
                     int id=-1, GLUI_Update_CB callback=null )

  GLUI_StaticText  add_statictext( cstring )

  GLUI_StaticText  add_statictext_to_panel( GLUI_Panel, cstring )

  GLUI_EditText  add_edittext( cstring, int= 1, void *,
                int id=-1, GLUI_Update_CB =null )

  GLUI_EditText  add_edittext_to_panel( GLUI_Panel, 
                     char *,
                     int data_type= 1,
                     void *live_var, int id=-1, 
                     GLUI_Update_CB callback=null )

  GLUI_Spinner  add_spinner( cstring, int =2,void *,
                  int id=-1, GLUI_Update_CB callback=null )

  GLUI_Spinner  add_spinner_to_panel( GLUI_Panel , 
                       cstring, int = 2, object, int id=-1,
                       GLUI_Update_CB = null )

  GLUI_Panel     add_panel( cstring, int =1 )

  GLUI_Panel     add_panel_to_panel( GLUI_Panel , cstring, int = 1 )

  GLUI_Rollout   add_rollout( cstring, int = 1 )

  GLUI_Rollout   add_rollout_to_panel( GLUI_Panel, cstring, int = 1 )

  void            set_main_gfx_window( int )

  int             get_glut_window_id()
  
  void            enable() 
  void            disable()

  void            sync_live()

  void            close()

  void            show()
  void            hide()
 

  int init( char *name, integer flags, int x, int y, int parent_window )

/class




class GLUI_Master_Object 

  GLUI_Node     gluis
  GLUI_Control  active_control
  GLUI_Control  curr_left_button_glut_menu
  GLUI          active_control_glui
  int           glui_id_counter

  GLUI_Glut_Window  find_glut_window( int )

  void           set_glutIdleFunc(f)


  void  set_left_button_glut_menu_control( GLUI_Control )



  void set_glutReshapeFunc(glut_reshape_CB)
  void set_glutKeyboardFunc(glut_keyboard_CB)
  void set_glutSpecialFunc(glut_special_CB)
  void set_glutMouseFunc(glut_mouse_CB)

  void set_glutDisplayFunc(glut_display_CB) 
  void set_glutTimerFunc( int millis, glut_entry_CB, int value)
  void set_glutOverlayDisplayFunc(glut_display_CB)
  void set_glutSpaceballMotionFunc(Int3_CB f)
  void set_glutSpaceballRotateFunc(Int3_CB f)
  void set_glutSpaceballButtonFunc(Int2_CB f)
  void set_glutTabletMotionFunc(Int2_CB f)
  void set_glutTabletButtonFunc(Int4_CB f)
  void set_glutMenuStatusFunc(Int3_CB f)
  void set_glutMenuStateFunc(Int1_CB f)
  void set_glutButtonBoxFunc(Int2_CB f)
  void set_glutDialsFunc(Int2_CB f)
  

  GLUI          create_glui( cstring, integer flags=0, int x=-1, int y=-1 ) 
  GLUI          create_glui_subwindow( int parent_window, integer flags=0 )
  GLUI          find_glui_by_window_id( int window_id )
  void           get_viewport_area( int *x, int *y, int *w, int *h )
  void           auto_set_viewport()
  void           close_all()
  void           sync_live_all()

  void           reshape()

  real          get_version()



/class

GLUI_Master_Object GLUI_Master




//int _glutBitmapWidthString( void *, cstring )
//void _glutBitmapString( void *, cstring )


void glui_display_func()
void glui_reshape_func( int w, int h )
void glui_keyboard_func(byte, int x, int y)
void glui_special_func(int key, int x, int y)
void glui_mouse_func(int button, int state, int x, int y)
void glui_motion_func(int x, int y)
void glui_passive_motion_func(int x, int y)
void glui_entry_func(int state)
void glui_visibility_func(int state)
void glui_idle_func()

void glui_parent_window_reshape_func( int w, int h )
void glui_parent_window_keyboard_func(byte key, int x, int y)
void glui_parent_window_mouse_func(int, int, int, int )
void glui_parent_window_special_func(int key, int x, int y)


/extern



extern

 GLUI_Checkbox   checkbox
 GLUI_Spinner    spinner
 GLUI_Spinner    light0_spinner
 GLUI_Spinner    light1_spinner
 GLUI_RadioGroup radio
 GLUI_Panel      obj_panel

/extern


/*
typedef void (*GLUI_Update_CB) (int id)
typedef void (*Int1_CB)        (int)
typedef void (*Int2_CB)        (int, int)
typedef void (*Int3_CB)        (int, int, int)
typedef void (*Int4_CB)        (int, int, int, int)
*/


enum
 LIGHT0_ENABLED_ID   = 200,
 LIGHT1_ENABLED_ID   = 201,
 LIGHT0_INTENSITY_ID = 250,
 LIGHT1_INTENSITY_ID = 251
/enum



enum 
  GLUI_GLUT_RESHAPE,
  GLUI_GLUT_KEYBOARD,
  GLUI_GLUT_DISPLAY,
  GLUI_GLUT_MOUSE,
  GLUI_GLUT_MOTION,
  GLUI_GLUT_SPECIAL,
  GLUI_GLUT_PASSIVE_MOTION,  
  GLUI_GLUT_ENTRY,
  GLUI_GLUT_VISIBILITY  
/enum


enum
  GLUI_CONTROL_CHECKBOX =1,
  GLUI_CONTROL_BUTTON,
  GLUI_CONTROL_RADIOBUTTON,
  GLUI_CONTROL_RADIOGROUP,
  GLUI_CONTROL_SLIDER,
  GLUI_CONTROL_STATICTEXT,
  GLUI_CONTROL_EDITTEXT,
  GLUI_CONTROL_BITMAP,
  GLUI_CONTROL_PANEL,
  GLUI_CONTROL_SPINNER,
  GLUI_CONTROL_SEPARATOR,
  GLUI_CONTROL_COLUMN,
  GLUI_CONTROL_LISTBOX,
  GLUI_CONTROL_MOUSE_INTERACTION,
  GLUI_CONTROL_ROTATION,
  GLUI_CONTROL_TRANSLATION,
  GLUI_CONTROL_ROLLOUT
/enum


enum
 GLUI_XOFF                    =  6,
 GLUI_YOFF                    =  6,
 GLUI_ITEMSPACING             =  3,
 GLUI_CHECKBOX_SIZE           = 13,
 GLUI_RADIOBUTTON_SIZE        = 13,
 GLUI_BUTTON_SIZE             = 20,
 GLUI_STATICTEXT_SIZE         = 13,
 GLUI_SEPARATOR_HEIGHT        =  8,
 GLUI_DEFAULT_CONTROL_WIDTH   =100,
 GLUI_DEFAULT_CONTROL_HEIGHT  = 13, 
 GLUI_EDITTEXT_BOXINNERMARGINX=  3,
 GLUI_EDITTEXT_HEIGHT         = 20,
 GLUI_EDITTEXT_WIDTH          =130,
 GLUI_EDITTEXT_MIN_INT_WIDTH  = 35,
 GLUI_EDITTEXT_MIN_TEXT_WIDTH = 50 ,
 GLUI_PANEL_NAME_DROP         =  8,
 GLUI_PANEL_EMBOSS_TOP        =  4,
 GLUI_ROTATION_WIDTH          = 50,
 GLUI_ROTATION_HEIGHT         = 68,
 GLUI_MOUSE_INTERACTION_WIDTH = 50,
 GLUI_MOUSE_INTERACTION_HEIGHT= 68,
 GLUI_PANEL_NONE              = 0,
 GLUI_PANEL_EMBOSSED          = 1,
 GLUI_PANEL_RAISED            = 2,
 GLUI_DEF_MAX_ARRAY           =30,
 GLUI_CONTROL_ACTIVE_MOUSEDOWN= 1,
 GLUI_CONTROL_ACTIVE_PERMANENT= 2,
 GLUI_ALIGN_CENTER            = 1,
 GLUI_ALIGN_RIGHT             = 2,
 GLUI_ALIGN_LEFT              = 3,
 GLUI_LIMIT_NONE              = 0,
 GLUI_LIMIT_CLAMP             = 1,
 GLUI_LIMIT_WRAP              = 2,
 GLUI_TRANSLATION_XY          = 0,
 GLUI_TRANSLATION_Z           = 1,
 GLUI_TRANSLATION_X           = 2,
 GLUI_TRANSLATION_Y           = 3,
 GLUI_TRANSLATION_LOCK_NONE   = 0,
 GLUI_TRANSLATION_LOCK_X      = 1,
 GLUI_TRANSLATION_LOCK_Y      = 2,
 GLUI_ACTIVATE_MOUSE          = 1,
 GLUI_ACTIVATE_TAB            = 2,
 GLUI_LIVE_NONE               = 0,
 GLUI_LIVE_INT                = 1,
 GLUI_LIVE_FLOAT              = 2,
 GLUI_LIVE_TEXT               = 3,
 GLUI_LIVE_DOUBLE             = 4,
 GLUI_LIVE_FLOAT_ARRAY        = 5

/enum



enum 
 GLUI_TRANSLATION_MOUSE_NONE=0,
 GLUI_TRANSLATION_MOUSE_UP,
 GLUI_TRANSLATION_MOUSE_DOWN,
 GLUI_TRANSLATION_MOUSE_LEFT,
 GLUI_TRANSLATION_MOUSE_RIGHT,
 GLUI_TRANSLATION_MOUSE_UP_LEFT,
 GLUI_TRANSLATION_MOUSE_UP_RIGHT,
 GLUI_TRANSLATION_MOUSE_DOWN_LEFT,
 GLUI_TRANSLATION_MOUSE_DOWN_RIGHT
/enum




enum
 GLUI_SUBWINDOW        = 2,
 GLUI_SUBWINDOW_TOP    = 4,
 GLUI_SUBWINDOW_BOTTOM = 8,
 GLUI_SUBWINDOW_LEFT   = 16,
 GLUI_SUBWINDOW_RIGHT  = 32
/enum

enum
 GLUI_EDITTEXT_TEXT     = 1,
 GLUI_EDITTEXT_INT      = 2,
 GLUI_EDITTEXT_FLOAT    = 3,
 GLUI_SPINNER_INT       = 2,
 GLUI_SPINNER_FLOAT     = 3
/enum


enum 
  GLUI_STDBITMAP_CHECKBOX_OFF=0,
  GLUI_STDBITMAP_CHECKBOX_ON,
  GLUI_STDBITMAP_RADIOBUTTON_OFF,
  GLUI_STDBITMAP_RADIOBUTTON_ON,
  GLUI_STDBITMAP_UP_ARROW,
  GLUI_STDBITMAP_DOWN_ARROW,
  GLUI_STDBITMAP_LEFT_ARROW,
  GLUI_STDBITMAP_RIGHT_ARROW,
  GLUI_STDBITMAP_SPINNER_UP_OFF,
  GLUI_STDBITMAP_SPINNER_UP_ON,
  GLUI_STDBITMAP_SPINNER_DOWN_OFF,
  GLUI_STDBITMAP_SPINNER_DOWN_ON,

  GLUI_STDBITMAP_CHECKBOX_OFF_DIS, 
  GLUI_STDBITMAP_CHECKBOX_ON_DIS,
  GLUI_STDBITMAP_RADIOBUTTON_OFF_DIS,
  GLUI_STDBITMAP_RADIOBUTTON_ON_DIS,
  GLUI_STDBITMAP_SPINNER_UP_DIS,
  GLUI_STDBITMAP_SPINNER_DOWN_DIS,
  GLUI_STDBITMAP_LISTBOX_UP,
  GLUI_STDBITMAP_LISTBOX_DOWN,
  GLUI_STDBITMAP_LISTBOX_UP_DIS,
  GLUI_STDBITMAP_NUM_ITEMS
/enum


enum
  GLUI_SPINNER_ARROW_WIDTH  =12,
  GLUI_SPINNER_ARROW_HEIGHT = 8,
  GLUI_SPINNER_ARROW_Y      = 2,

  GLUI_SPINNER_STATE_NONE   =0,
  GLUI_SPINNER_STATE_UP     =1,
  GLUI_SPINNER_STATE_DOWN   =2,
  GLUI_SPINNER_STATE_BOTH   =3,

  GLUI_SPINNER_DEFAULT_GROWTH_EXP :  1.05
/enum
                 


