
extern float xy_aspect;
extern int   last_x, last_y;
extern float rotationX;
extern float rotationY;

/** These are the live variables passed into GLUI ***/
extern int   wireframe;
extern int   obj_type;
extern int   segments;
extern int   segments2;
extern int   light0_enabled;
extern int   light1_enabled;
extern float light0_intensity;
extern float light1_intensity;
extern int   main_window;
extern float scale;
extern int   show_sphere;
extern int   show_torus;

/** Pointers to the windows and some of the controls we'll create **/
extern GLUI *glui;
extern GLUI_Checkbox   *checkbox;
extern GLUI_Spinner    *spinner, *light0_spinner, *light1_spinner;
extern GLUI_RadioGroup *radio;
extern GLUI_Panel      *obj_panel;

/** User IDs for callbacks ********/
#define LIGHT0_ENABLED_ID    200
#define LIGHT1_ENABLED_ID    201
#define LIGHT0_INTENSITY_ID  250
#define LIGHT1_INTENSITY_ID  251

/** Miscellaneous global variables **********/
extern GLfloat light0_ambient[];
extern GLfloat light0_diffuse[];
extern GLfloat light0_position[];

extern GLfloat light1_ambient[];
extern GLfloat light1_diffuse[];
extern GLfloat light1_position[];




/* GLUI control callback                                                 */
void control_cb( int control );

void myGlutKeyboard(unsigned char Key, int x, int y);

void myGlutMenu( int value );

void myGlutIdle( void );

void myGlutMouse(int button, int button_state, int x, int y );

void myGlutMotion(int x, int y );

void myGlutReshape( int x, int y );

/* Disables lighting, then draws RGB axes                                */
void draw_axes( float scale );

void myGlutDisplay( void );

